/**
 * Author:      NS
 * Created:     25.02.2020
 *
 * Description: Make a sorting 
 */

#include <stdio.h>
#include <string.h>

//STRUCT: //////////////////////////////////////////////
typedef struct
{
	char country[15];
	char city[];
}Country;

typedef struct
{
	char city[10];
	char street[15];
	int house;
}Adr;

typedef struct 
{
	char name[15];
	Adr address;
}Data;

//FUNCT: //////////////////////////////////////////////
void fileNames(char[], char[]);
void sorting (FILE*, FILE *, FILE *, Country*, Adr*, Data*, int, char(*)[]);
int fileLength(FILE *);

//MAIN: //////////////////////////////////////////////

int main(void)
{
	FILE *na1, *na2, *nt1, *nt2; //not used problem
	
	char na1N[10]= "", na2N[10]= "", nt1N[10]= "",nt2N[10]= "";


	fileNames("na1", na1N);
	fileNames("na2", na2N);
	fileNames("nt1", nt1N);
	fileNames("nt2", nt2N);
	
	na1 = fopen(na1N, "r");
	na2 = fopen(na2N, "r");
	nt1 = fopen(nt1N, "w");
	nt2 = fopen(nt2N, "w");
	
	Country c;
	Country *count = &c;
	
	Adr ad;
	Adr *adr = &ad;
	
	Data d;
	Data *data = &d;
	
	
	
	int leng = fileLength(na1);
 
	
// ARRAY OF UNIQ COUNTRIES://///////////////////////////////////////////////////////////////
	char countries[leng][100], temp[100];
	int i, j, k=0, check;

	while (fscanf(na1, "%s %*s", count->country) != EOF) 
		{
			for (i=0; i<leng; i++)
			{
				check =0;
				
				for (j=0; j<i; j++)
				{
					if (strcmp(countries[j], count->country) == 0)
					{
						check = 1;
					}
				}
				if (check == 0)
				{
					strcpy(countries[k], count->country);
					k++; 
				} 
			}
		}
			

			
// sorting:	
	for(i=0; i<leng; i++)
	{
		
		for (j=i+1; j<leng; j++)
		{
			if(strcmp(countries[i],countries[j])>0)
			{
				strcpy(temp,countries[i]);
				strcpy(countries[i],countries[j]);
				strcpy(countries[j],temp);
			}
		}
	}	
	
	
	sorting (na1, na2, nt1, count, adr, data, leng, countries);

	fclose(na1);
	fclose(na2);
	fclose(nt1);
	fclose(nt2);
	
	return 0;
	
}


//FILE NAMES: 

void fileNames(char name[], char fileName[])
{
	
	printf("Please enter the name for %s\n", name);
	scanf("%s", fileName);
	
}
//SORTING: 

void sorting (FILE *na1, FILE *na2, FILE *nt1, Country* c, Adr* a, Data* d, int n, char coun[n][100])   // IS ADR NEEDED? DELETE
{
	char curCount[15];
	int i;
	
	if (na1 != NULL && na2!= NULL)
	{
		
		for (i=0; i<n; i++)
			{
				while (fscanf(na2, "%s %s %s %d", d->name, d->address.city, d->address.street, &d->address.house ) != EOF) 
				{
					while (fscanf(na1, "%s %s", c->country, c->city) != EOF) 
					{
						if (strcmp(d->address.city, c->city) == 0)
						{
							strcpy(curCount, c->country);
							
						}
					}
				}
				if (strcmp(coun[i], curCount) == 0)
				{
					printf("%s, %s, %s, %d", d->name, d->address.city, d->address.street, d->address.house);
					fprintf(nt1, "%s, %s, %s, %d", d->name, d->address.city, d->address.street, d->address.house);
				}
				
			}
		
	}
}
//GET THE LENGTH OF THE FILE: 
int fileLength(FILE *f)
{
	int i = 0;
	while (getc(f) != EOF) 
		{
			i++;
		}
	return i;
}

